% clean_up

nk = zeros(1, maxK);
for k = 1:K
    nk(k) = sum(z == k * ones(n, 1));
end

flag = 1;

if (flag == 1)

[nk, perm] = sort(nk, 'descend');
K = 1;
while (K <= maxK && nk(K) > 0)
    K = K + 1;
end
K = K - 1;

mu0 = mu;
U0 = U;
Q0 = Q;
d0 = d;
L0 = L;
z0 = z;

for k = 1:K
    old_k = perm(k);
    if (k ~= old_k)
        mu(k, :) = mu0(old_k, :);
        U(k, :, :) = U0(old_k, :, :);
        Q(:, k) = Q0(:, old_k);
        d(k) = d0(old_k);
        L(k, :) = L0(old_k, :);
        ind = (z0 == old_k * ones(n, 1));
        z = z + ind .* ((k-old_k) * ones(n, 1));
    end
end

for k = K+1:maxK
    mu(k, :) = zeros(1, D);
    U(k, :, :) = eye(D);
    Q(:, k) = 1e100 * ones(n, 1);
    d(k) = 0;
end

end